aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorDave Chinner <dchinner@redhat.com>2018-05-08 09:05:51 +1000
committerEryu Guan <guaneryu@gmail.com>2018-05-11 18:40:04 +0800
commit272ddcdd191e2979a3d03fd5b8e3dde7ef9233eb (patch)
tree2fa757829a376611de3085c598e9980969eb872c
parentf3851ad630ba0316acf90fc48e995ee1eb44e45e (diff)
downloadxfstests-dev-272ddcdd191e2979a3d03fd5b8e3dde7ef9233eb.tar.gz
xfs: test inobt/on disk free state mismatches
Fuzzing has recently uncovered a couple of conditions where we don't detect corruptions that reallocate already allocated inodes. This test exercises those cases, and checks that we shut down the filesystem appropriately when such a corruption occurs. Signed-Off-By: Dave Chinner <dchinner@redhat.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rwxr-xr-xtests/xfs/13273
-rw-r--r--tests/xfs/132.out26
-rw-r--r--tests/xfs/group1
3 files changed, 100 insertions, 0 deletions
diff --git a/tests/xfs/132 b/tests/xfs/132
new file mode 100755
index 0000000000..6bb03e7998
--- /dev/null
+++ b/tests/xfs/132
@@ -0,0 +1,73 @@
+#! /bin/bash
+# FS QA Test No. 132
+#
+# Catch inobt/on disk inode free state mismatches on V4 filesystems
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Red Hat, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs xfs
+_supported_os Linux
+
+# we intentionally corrupt the filesystem, so don't check it after the test
+_require_scratch_nocheck
+
+# on success, we'll get a shutdown filesystem with a really noisy log message
+# due to transaction cancellation. Hence we don't want to check dmesg here.
+_disable_dmesg_check
+
+_require_xfs_mkfs_crc
+_scratch_mkfs -m crc=0 > $seqres.full 2>&1
+
+# corrupt an inode in the root inode chunk
+root_ino=$(_scratch_xfs_get_metadata_field 'rootino' 'sb 0')
+corrupt_ino=$((root_ino + 15))
+_scratch_xfs_set_metadata_field 'core.mode' 0100644 "inode $corrupt_ino"
+
+_scratch_mount
+
+# The corrupt inode should be tripped over during these initial file creates.
+touch $SCRATCH_MNT/file{0,1,2,3,4,5}{0,1,2,3,4,5} 2>&1 | _filter_scratch
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/132.out b/tests/xfs/132.out
new file mode 100644
index 0000000000..3a86ec328f
--- /dev/null
+++ b/tests/xfs/132.out
@@ -0,0 +1,26 @@
+QA output created by 132
+core.mode = 0100644
+touch: cannot touch 'SCRATCH_MNT/file20': Structure needs cleaning
+touch: cannot touch 'SCRATCH_MNT/file21': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file22': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file23': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file24': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file25': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file30': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file31': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file32': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file33': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file34': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file35': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file40': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file41': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file42': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file43': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file44': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file45': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file50': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file51': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file52': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file53': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file54': Input/output error
+touch: cannot touch 'SCRATCH_MNT/file55': Input/output error
diff --git a/tests/xfs/group b/tests/xfs/group
index 66728e369f..e8c802c960 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -129,6 +129,7 @@
129 auto quick clone
130 fuzzers clone
131 auto quick clone
+132 auto quick
133 dangerous_fuzzers
134 dangerous_fuzzers
135 auto logprint quick v2log